// #!/usr/bin/env babel-node
// -*- coding: utf-8 -*-

/** @module configurator */
'use strict';
/* !
    region header
    Copyright Torben Sickert (info["~at~"]torben.website) 16.12.2012

    License
    -------

    This library written by Torben Sickert stand under a creative commons
    naming 3.0 unported license.
    See https://creativecommons.org/licenses/by/3.0/deed.de
    endregion
*/
// region imports

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.resolvedConfiguration = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _clientnode = _interopRequireWildcard(require("clientnode"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _helper = _interopRequireDefault(require("./helper"));

var _package = require("./package.json");

var _type4 = require("./type");

var _specificConfiguratio;

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/*
    To assume to go two folder up from this file until there is no
    "node_modules" parent folder is usually resilient again dealing with
    projects where current working directory isn't the projects directory and
    this library is located as a nested dependency.
*/
_package.configuration["default"].path.context = __dirname;

while (true) {
  _package.configuration["default"].path.context = _path["default"].resolve(_package.configuration["default"].path.context, '../../');
  if (_path["default"].basename(_path["default"].dirname(_package.configuration["default"].path.context)) !== 'node_modules') break;
}

if (_path["default"].basename(_path["default"].dirname(process.cwd())) === 'node_modules' || _path["default"].basename(_path["default"].dirname(process.cwd())) === '.staging' && _path["default"].basename(_path["default"].dirname(_path["default"].dirname(process.cwd()))) === 'node_modules') {
  /*
      NOTE: If we are dealing was a dependency project use current directory
      as context.
  */
  _package.configuration["default"].path.context = process.cwd();
  _package.configuration["default"].contextType = 'dependency';
} else
  /*
      NOTE: If the current working directory references this file via a
      linked "node_modules" folder using current working directory as context
      is a better assumption than two folders up the hierarchy.
  */
  try {
    if (_fs["default"].lstatSync(_path["default"].join(process.cwd(), 'node_modules')).isSymbolicLink()) _package.configuration["default"].path.context = process.cwd();
  } catch (error) {// continue regardless of error
  }

var specificConfiguration = {};

try {
  /* eslint-disable no-eval */
  specificConfiguration = eval('require')(_path["default"].join(_package.configuration["default"].path.context, 'package'));
  /* eslint-enable no-eval */
} catch (error) {
  _package.configuration["default"].path.context = process.cwd();
}

var name = typeof specificConfiguration.name === 'string' ? specificConfiguration.name : 'mockup';
specificConfiguration = specificConfiguration.webOptimizer || {};
specificConfiguration.name = name; // endregion
// region determine debug mode
// NOTE: Given node command line arguments results in "npm_config_*"
// environment variables.

var debug = _package.configuration["default"].debug;
if (typeof specificConfiguration.debug === 'boolean') debug = specificConfiguration.debug;else if (process.env.npm_config_dev === 'true' || typeof process.env.NODE_ENV === 'string' && ['debug', 'dev', 'development'].includes(process.env.NODE_ENV)) debug = true;
if (debug) // NOTE: We have to avoid that some pre-processor removes this assignment.
  eval("process.env.NODE_ENV = 'development'"); // endregion
// region loading default configuration

_package.configuration["default"].path.context += '/'; // Merges final default configuration object depending on given target
// environment.

var libraryConfiguration = _package.configuration.library;
var configuration;
if (debug) configuration = _clientnode["default"].extend(true, _clientnode["default"].modifyObject(_package.configuration["default"], _package.configuration.debug), _package.configuration.debug);else configuration = _package.configuration["default"];
configuration.debug = debug;
if ((0, _typeof2["default"])(configuration.library) === 'object') _clientnode["default"].extend(true, _clientnode["default"].modifyObject(libraryConfiguration, configuration.library), configuration.library);
if (configuration.library && ((_specificConfiguratio = specificConfiguration) === null || _specificConfiguratio === void 0 ? void 0 : _specificConfiguratio.library) !== false) configuration = _clientnode["default"].extend(true, _clientnode["default"].modifyObject(configuration, libraryConfiguration), libraryConfiguration); // endregion
// region merging and evaluating task specific and dynamic configurations
// / region load additional dynamically given configuration

var count = 0;
var filePath = null;

while (true) {
  var newFilePath = configuration.path.context + ".dynamicConfiguration-".concat(count, ".json");
  if (!_clientnode["default"].isFileSync(newFilePath)) break;
  filePath = newFilePath;
  count += 1;
}

var runtimeInformation = {
  givenCommandLineArguments: process.argv
};

if (filePath) {
  runtimeInformation = JSON.parse(_fs["default"].readFileSync(filePath, {
    encoding: configuration.encoding
  }));

  _fs["default"].unlink(filePath, function (error) {
    if (error) throw error;
  });
} // // region task specific configuration
// /// region apply task type specific configuration


if (runtimeInformation.givenCommandLineArguments.length > 2) {
  var _iterator = _createForOfIteratorHelper(_type4.SubConfigurationTypes),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var type = _step.value;
      if (runtimeInformation.givenCommandLineArguments[2] === type || debug && type === 'debug') for (var _i = 0, _arr = [configuration, specificConfiguration]; _i < _arr.length; _i++) {
        var configurationTarget = _arr[_i];
        if (_clientnode["default"].isPlainObject(configurationTarget[type])) _clientnode["default"].extend(true, _clientnode["default"].modifyObject(configurationTarget, configurationTarget[type]), configurationTarget[type]);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
} // /// endregion
// /// region clear task type specific configurations


var _iterator2 = _createForOfIteratorHelper(_type4.SubConfigurationTypes),
    _step2;

try {
  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
    var _type3 = _step2.value;

    for (var _i2 = 0, _arr2 = [configuration, specificConfiguration]; _i2 < _arr2.length; _i2++) {
      var _configurationTarget = _arr2[_i2];
      if (Object.prototype.hasOwnProperty.call(_configurationTarget, _type3) && (0, _typeof2["default"])(_configurationTarget[_type3]) === 'object') delete _configurationTarget[_type3];
    }
  } // /// endregion
  // // endregion
  // / endregion

} catch (err) {
  _iterator2.e(err);
} finally {
  _iterator2.f();
}

_clientnode["default"].extend(true, _clientnode["default"].modifyObject(_clientnode["default"].modifyObject(configuration, specificConfiguration), runtimeInformation), specificConfiguration, runtimeInformation);

var result = null;
if (runtimeInformation.givenCommandLineArguments.length > 3) result = _clientnode["default"].stringParseEncodedObject(runtimeInformation.givenCommandLineArguments[runtimeInformation.givenCommandLineArguments.length - 1], configuration, 'configuration');

if (result !== null && (0, _typeof2["default"])(result) === 'object') {
  if (Object.prototype.hasOwnProperty.call(result, '__reference__')) {
    var referenceNames = [].concat(result.__reference__);
    delete result.__reference__;

    var _iterator3 = _createForOfIteratorHelper(referenceNames),
        _step3;

    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var _name = _step3.value;

        _clientnode["default"].extend(true, result, configuration[_name]);
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
  }

  _clientnode["default"].extend(true, _clientnode["default"].modifyObject(configuration, result), result);
} // Removing comments (default key name to delete is "#").


configuration = _clientnode["default"].removeKeys(configuration); // endregion
// / region determine existing pre compiled dll manifests file paths

if (_clientnode["default"].isDirectorySync(configuration.path.target.base)) {
  var _iterator4 = _createForOfIteratorHelper(_fs["default"].readdirSync(configuration.path.target.base)),
      _step4;

  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var fileName = _step4.value;
      if (/^.*\.dll-manifest\.json$/.exec(fileName)) configuration.dllManifestFilePaths.push(_path["default"].resolve(configuration.path.target.base, fileName));
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }
} // / endregion
// / region build absolute paths


configuration.path.base = _path["default"].resolve(configuration.path.context, configuration.path.base);

for (var key in configuration.path) {
  if (Object.prototype.hasOwnProperty.call(configuration.path, key) && key !== 'base' && typeof configuration.path[key] === 'string') configuration.path[key] = _path["default"].resolve(configuration.path.base, configuration.path[key]) + '/';else if (key !== 'configuration' && _clientnode["default"].isPlainObject(configuration.path[key])) {
    configuration.path[key].base = _path["default"].resolve(configuration.path.base, configuration.path[key].base);

    for (var subKey in configuration.path[key]) {
      if (Object.prototype.hasOwnProperty.call(configuration.path[key], subKey) && !['base', 'public'].includes(subKey) && typeof configuration.path[key][subKey] === 'string') configuration.path[key][subKey] = _path["default"].resolve(configuration.path[key].base, configuration.path[key][subKey]) + '/';else if (_clientnode["default"].isPlainObject(configuration.path[key][subKey])) {
        configuration.path[key][subKey].base = _path["default"].resolve(configuration.path[key].base, configuration.path[key][subKey].base);

        for (var subSubKey in configuration.path[key][subKey]) {
          if (Object.prototype.hasOwnProperty.call(configuration.path[key][subKey], subSubKey) && subSubKey !== 'base' && typeof configuration.path[key][subKey][subSubKey] === 'string') configuration.path[key][subKey][subSubKey] = _path["default"].resolve(configuration.path[key][subKey].base, configuration.path[key][subKey][subSubKey]) + '/';
        }
      }
    }
  }
} // / endregion


var now = new Date();
/*
    NOTE: The configuration is not yet fully resolved but will be transformed
    in place in the following lines of code.
*/

var resolvedConfiguration = _clientnode["default"].evaluateDynamicData(configuration, {
  currentPath: process.cwd(),
  fileSystem: _fs["default"],
  Helper: _helper["default"],
  isDLLUseful: 2 < configuration.givenCommandLineArguments.length && (['build:dll', 'watch:dll'].includes(configuration.givenCommandLineArguments[2]) || configuration.dllManifestFilePaths.length && ['build', 'serve', 'test:browser'].includes(configuration.givenCommandLineArguments[2])),
  optionalRequire: _clientnode.optionalRequire,
  path: _path["default"],
  require: _clientnode.currentRequire,
  Tools: _clientnode["default"],
  webOptimizerPath: __dirname,
  now: now,
  nowUTCTimestamp: _clientnode["default"].numberGetUTCTimestamp(now)
}); // region consolidate file specific build configuration
// Apply default file level build configurations to all file type specific
// ones.


exports.resolvedConfiguration = resolvedConfiguration;
var defaultConfiguration = resolvedConfiguration.buildContext.types["default"];
delete resolvedConfiguration.buildContext.types["default"];

for (var _type in resolvedConfiguration.buildContext.types) {
  if (Object.prototype.hasOwnProperty.call(resolvedConfiguration.buildContext.types, _type)) resolvedConfiguration.buildContext.types[_type] = _clientnode["default"].extend(true, {}, defaultConfiguration, _clientnode["default"].extend(true, {
    extension: _type
  }, resolvedConfiguration.buildContext.types[_type], {
    type: _type
  }));
} // endregion
// region resolve module location and determine which asset types are needed


resolvedConfiguration.module.locations = _helper["default"].determineModuleLocations(resolvedConfiguration.injection.entry.normalized, resolvedConfiguration.module.aliases, resolvedConfiguration.module.replacements.normal, {
  file: resolvedConfiguration.extensions.file.internal
}, resolvedConfiguration.path.context, resolvedConfiguration.path.source.asset.base);
resolvedConfiguration.injection = _helper["default"].resolveAutoInjection(resolvedConfiguration.injection, _helper["default"].resolveBuildConfigurationFilePaths(resolvedConfiguration.buildContext.types, resolvedConfiguration.path.source.asset.base, _helper["default"].normalizePaths(resolvedConfiguration.path.ignore.concat(resolvedConfiguration.module.directoryNames, resolvedConfiguration.loader.directoryNames).map(function (filePath) {
  return _path["default"].resolve(resolvedConfiguration.path.context, filePath);
}).filter(function (filePath) {
  return !resolvedConfiguration.path.context.startsWith(filePath);
})), resolvedConfiguration["package"].main.fileNames), resolvedConfiguration.module.aliases, resolvedConfiguration.module.replacements.normal, resolvedConfiguration.extensions, resolvedConfiguration.path.context, resolvedConfiguration.path.source.asset.base, resolvedConfiguration.path.ignore);
var givenInjection = resolvedConfiguration.injection.entry;
resolvedConfiguration.injection.entry = {
  given: givenInjection,
  normalized: _helper["default"].resolveModulesInFolders(_helper["default"].normalizeGivenInjection(givenInjection), resolvedConfiguration.module.aliases, resolvedConfiguration.module.replacements.normal, resolvedConfiguration.path.context, resolvedConfiguration.path.source.asset.base, resolvedConfiguration.path.ignore.concat(resolvedConfiguration.module.directoryNames, resolvedConfiguration.loader.directoryNames).map(function (filePath) {
    return _path["default"].resolve(resolvedConfiguration.path.context, filePath);
  }).filter(function (filePath) {
    return !resolvedConfiguration.path.context.startsWith(filePath);
  }))
};
resolvedConfiguration.needed = {
  javaScript: configuration.debug && ['serve', 'test:browser'].includes(resolvedConfiguration.givenCommandLineArguments[2])
};

for (var chunkName in resolvedConfiguration.injection.entry.normalized) {
  if (Object.prototype.hasOwnProperty.call(resolvedConfiguration.injection.entry.normalized, chunkName)) {
    var _iterator5 = _createForOfIteratorHelper(resolvedConfiguration.injection.entry.normalized[chunkName]),
        _step5;

    try {
      for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
        var moduleID = _step5.value;

        var _filePath = _helper["default"].determineModuleFilePath(moduleID, resolvedConfiguration.module.aliases, resolvedConfiguration.module.replacements.normal, {
          file: resolvedConfiguration.extensions.file.internal
        }, resolvedConfiguration.path.context,
        /*
            NOTE: We doesn't use
            "resolvedConfiguration.path.source.asset.base" because we
            have already resolve all module ids.
        */
        './', resolvedConfiguration.path.ignore, resolvedConfiguration.module.directoryNames, resolvedConfiguration["package"].main.fileNames, resolvedConfiguration["package"].main.propertyNames, resolvedConfiguration["package"].aliasPropertyNames, resolvedConfiguration.encoding);

        var _type2 = null;
        if (_filePath) _type2 = _helper["default"].determineAssetType(_filePath, resolvedConfiguration.buildContext.types, resolvedConfiguration.path);else throw new Error("Given request \"".concat(moduleID, "\" couldn't be resolved."));
        if (_type2) resolvedConfiguration.needed[_type2] = true;
      }
    } catch (err) {
      _iterator5.e(err);
    } finally {
      _iterator5.f();
    }
  }
} // endregion
// region adding special aliases
// NOTE: This alias couldn't be set in the "package.json" file since this would
// result in an endless loop.


resolvedConfiguration.loader.aliases.webOptimizerDefaultTemplateFileLoader = '';

var _iterator6 = _createForOfIteratorHelper(Array.isArray(resolvedConfiguration.files.defaultHTML.template.use) ? resolvedConfiguration.files.defaultHTML.template.use : [resolvedConfiguration.files.defaultHTML.template.use]),
    _step6;

try {
  for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
    var loader = _step6.value;
    if (resolvedConfiguration.loader.aliases.webOptimizerDefaultTemplateFileLoader) resolvedConfiguration.loader.aliases.webOptimizerDefaultTemplateFileLoader += '!';
    resolvedConfiguration.loader.aliases.webOptimizerDefaultTemplateFileLoader += loader.loader;
    if (loader.options) resolvedConfiguration.loader.aliases.webOptimizerDefaultTemplateFileLoader += '?' + _clientnode["default"].convertCircularObjectToJSON(loader.options);
  }
} catch (err) {
  _iterator6.e(err);
} finally {
  _iterator6.f();
}

resolvedConfiguration.module.aliases.webOptimizerDefaultTemplateFilePath = resolvedConfiguration.files.defaultHTML.template.filePath; // endregion
// region apply html webpack plugin workarounds

/*
    NOTE: Provides a workaround to handle a bug with chained loader
    configurations.
*/

var _iterator7 = _createForOfIteratorHelper(resolvedConfiguration.files.html),
    _step7;

try {
  for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
    var htmlConfiguration = _step7.value;

    _clientnode["default"].extend(true, htmlConfiguration, resolvedConfiguration.files.defaultHTML);

    htmlConfiguration.template.request = htmlConfiguration.template.filePath;

    if (htmlConfiguration.template.filePath !== resolvedConfiguration.files.defaultHTML.template.filePath && htmlConfiguration.template.options) {
      var requestString = new String(htmlConfiguration.template.request + _clientnode["default"].convertCircularObjectToJSON(htmlConfiguration.template.options));
      /* eslint-disable
          @typescript-eslint/unbound-method,
          @typescript-eslint/ban-ts-ignore
      */
      // @ts-ignore: Monkeypatching is not allowed by typescript.

      requestString.replace = function (value) {
        return function () {
          return value;
        };
      }(htmlConfiguration.template.filePath);
      /* eslint-enable
          @typescript-eslint/unbound-method,
          @typescript-eslint/ban-ts-ignore
      */


      htmlConfiguration.template.request = requestString;
    }
  } // endregion

} catch (err) {
  _iterator7.e(err);
} finally {
  _iterator7.f();
}

var _default = resolvedConfiguration; // region vim modline
// vim: set tabstop=4 shiftwidth=4 expandtab:
// vim: foldmethod=marker foldmarker=region,endregion:
// endregion

exports["default"] = _default;
