#!/usr/bin/env node
// -*- coding: utf-8 -*-

/** @module weboptimizer */
'use strict';
/* !
    region header
    [Project page](https://torben.website/webOptimizer)

    Copyright Torben Sickert (info["~at~"]torben.website) 16.12.2012

    License
    -------

    This library written by Torben Sickert stand under a creative commons
    naming 3.0 unported license.
    See https://creativecommons.org/licenses/by/3.0/deed.de
    endregion
*/
// region imports

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _child_process = require("child_process");

var _clientnode = _interopRequireWildcard(require("clientnode"));

var _fs = _interopRequireWildcard(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _rimraf = _interopRequireDefault(require("rimraf"));

var _configurator = _interopRequireDefault(require("./configurator"));

var _helper = _interopRequireDefault(require("./helper"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

// NOTE: Environment variables can only be strings.
process.env.UV_THREADPOOL_SIZE = '128';
/**
 * Main entry point.
 * @returns Nothing.
 */

var main = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            return _context3.delegateYield( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
              var processOptions, childProcessOptions, childProcesses, processPromises, possibleArguments, closeEventHandlers, dynamicConfiguration, count, filePath, additionalArguments, _iterator, _step, file, _iterator2, _step2, _filePath, buildConfigurations, tidiedUp, tidyUp, testModuleFilePaths, _iterator7, _step7, buildConfiguration, expression, _iterator8, _step8, _filePath6, handleTask, finished, closeHandler, _iterator12, _step12, closeEventName;

              return _regenerator["default"].wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      // region controller
                      processOptions = {
                        cwd: _configurator["default"].path.context,
                        env: process.env
                      };
                      childProcessOptions = _clientnode["default"].extend({
                        shell: true,
                        stdio: 'inherit'
                      }, processOptions);
                      childProcesses = [];
                      processPromises = [];
                      possibleArguments = ['build', 'build:dll', 'clear', 'document', 'lint', 'preinstall', 'serve', 'test', 'test:browser', 'check:types'];
                      closeEventHandlers = [];

                      if (!(_configurator["default"].givenCommandLineArguments.length > 2)) {
                        _context2.next = 71;
                        break;
                      }

                      // region temporary save dynamically given configurations
                      // NOTE: We need a copy of given arguments array.
                      dynamicConfiguration = {
                        givenCommandLineArguments: _configurator["default"].givenCommandLineArguments.slice()
                      };
                      if (_configurator["default"].givenCommandLineArguments.length > 3 && _clientnode["default"].stringParseEncodedObject(_configurator["default"].givenCommandLineArguments[_configurator["default"].givenCommandLineArguments.length - 1], _configurator["default"], 'configuration')) _configurator["default"].givenCommandLineArguments.pop();
                      count = 0;
                      filePath = _path["default"].resolve(_configurator["default"].path.context, ".dynamicConfiguration-".concat(count, ".json"));

                    case 11:
                      if (!true) {
                        _context2.next = 20;
                        break;
                      }

                      filePath = _path["default"].resolve(_configurator["default"].path.context, ".dynamicConfiguration-".concat(count, ".json"));
                      _context2.next = 15;
                      return _clientnode["default"].isFile(filePath);

                    case 15:
                      if (_context2.sent) {
                        _context2.next = 17;
                        break;
                      }

                      return _context2.abrupt("break", 20);

                    case 17:
                      count += 1;
                      _context2.next = 11;
                      break;

                    case 20:
                      _context2.next = 22;
                      return _fs.promises.writeFile(filePath, JSON.stringify(dynamicConfiguration));

                    case 22:
                      additionalArguments = process.argv.splice(3); // / region register exit handler to tidy up

                      closeEventHandlers.push(function (error) {
                        // NOTE: Close handler have to be synchronous.
                        if (_clientnode["default"].isFileSync(filePath)) _fs["default"].unlinkSync(filePath);
                        if (error) throw error;
                      }); // / endregion
                      // endregion
                      // region handle clear

                      /*
                          NOTE: Some tasks could depend on previously created dll
                          packages so a clean should not be performed in that case.
                          NOTE: If we have a dependency cycle we need to preserve files
                          during pre-install phase.
                      */

                      if (!(!['build', 'preinstall', 'serve', 'test', 'test:browser'].includes(_configurator["default"].givenCommandLineArguments[2]) && possibleArguments.includes(_configurator["default"].givenCommandLineArguments[2]))) {
                        _context2.next = 61;
                        break;
                      }

                      if (!(_path["default"].resolve(_configurator["default"].path.target.base) === _path["default"].resolve(_configurator["default"].path.context))) {
                        _context2.next = 52;
                        break;
                      }

                      _context2.next = 28;
                      return _clientnode["default"].walkDirectoryRecursively(_configurator["default"].path.target.base, /*#__PURE__*/function () {
                        var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(file) {
                          var type, _file$stats;

                          return _regenerator["default"].wrap(function _callee$(_context) {
                            while (1) {
                              switch (_context.prev = _context.next) {
                                case 0:
                                  if (!_helper["default"].isFilePathInLocation(file.path, _configurator["default"].path.ignore.concat(_configurator["default"].module.directoryNames, _configurator["default"].loader.directoryNames).map(function (filePath) {
                                    return _path["default"].resolve(_configurator["default"].path.context, filePath);
                                  }).filter(function (filePath) {
                                    return !_configurator["default"].path.context.startsWith(filePath);
                                  }))) {
                                    _context.next = 2;
                                    break;
                                  }

                                  return _context.abrupt("return", false);

                                case 2:
                                  _context.t0 = _regenerator["default"].keys(_configurator["default"].buildContext.types);

                                case 3:
                                  if ((_context.t1 = _context.t0()).done) {
                                    _context.next = 15;
                                    break;
                                  }

                                  type = _context.t1.value;

                                  if (!new RegExp(_configurator["default"].buildContext.types[type].filePathPattern).test(file.path)) {
                                    _context.next = 13;
                                    break;
                                  }

                                  if (!((_file$stats = file.stats) !== null && _file$stats !== void 0 && _file$stats.isDirectory())) {
                                    _context.next = 10;
                                    break;
                                  }

                                  _context.next = 9;
                                  return new Promise(function (resolve, reject) {
                                    return (0, _rimraf["default"])(file.path, {
                                      glob: false
                                    }, function (error) {
                                      return error ? reject(error) : resolve();
                                    });
                                  });

                                case 9:
                                  return _context.abrupt("return", false);

                                case 10:
                                  _context.next = 12;
                                  return _fs.promises.unlink(file.path);

                                case 12:
                                  return _context.abrupt("break", 15);

                                case 13:
                                  _context.next = 3;
                                  break;

                                case 15:
                                case "end":
                                  return _context.stop();
                              }
                            }
                          }, _callee);
                        }));

                        return function (_x) {
                          return _ref2.apply(this, arguments);
                        };
                      }());

                    case 28:
                      _context2.t0 = _createForOfIteratorHelper;
                      _context2.next = 31;
                      return _clientnode["default"].walkDirectoryRecursively(_configurator["default"].path.target.base, function () {
                        return false;
                      }, _configurator["default"].encoding);

                    case 31:
                      _context2.t1 = _context2.sent;
                      _iterator = (0, _context2.t0)(_context2.t1);
                      _context2.prev = 33;

                      _iterator.s();

                    case 35:
                      if ((_step = _iterator.n()).done) {
                        _context2.next = 42;
                        break;
                      }

                      file = _step.value;

                      if (!(file.name.length > '.dll-manifest.json'.length && file.name.endsWith('.dll-manifest.json') || file.name.startsWith('npm-debug'))) {
                        _context2.next = 40;
                        break;
                      }

                      _context2.next = 40;
                      return _fs.promises.unlink(file.path);

                    case 40:
                      _context2.next = 35;
                      break;

                    case 42:
                      _context2.next = 47;
                      break;

                    case 44:
                      _context2.prev = 44;
                      _context2.t2 = _context2["catch"](33);

                      _iterator.e(_context2.t2);

                    case 47:
                      _context2.prev = 47;

                      _iterator.f();

                      return _context2.finish(47);

                    case 50:
                      _context2.next = 54;
                      break;

                    case 52:
                      _context2.next = 54;
                      return new Promise(function (resolve, reject) {
                        return (0, _rimraf["default"])(_configurator["default"].path.target.base, {
                          glob: false
                        }, function (error) {
                          return error ? reject(error) : resolve();
                        });
                      });

                    case 54:
                      _context2.next = 56;
                      return _clientnode["default"].isDirectory(_configurator["default"].path.apiDocumentation);

                    case 56:
                      if (!_context2.sent) {
                        _context2.next = 59;
                        break;
                      }

                      _context2.next = 59;
                      return new Promise(function (resolve, reject) {
                        return (0, _rimraf["default"])(_configurator["default"].path.apiDocumentation, {
                          glob: false
                        }, function (error) {
                          return error ? reject(error) : resolve();
                        });
                      });

                    case 59:
                      _iterator2 = _createForOfIteratorHelper(_configurator["default"].path.tidyUpOnClear);

                      try {
                        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                          _filePath = _step2.value;
                          if (_filePath) if (_clientnode["default"].isFileSync(_filePath)) // NOTE: Close handler have to be synchronous.
                            _fs["default"].unlinkSync(_filePath);else if (_clientnode["default"].isDirectorySync(_filePath)) _rimraf["default"].sync(_filePath, {
                            glob: false
                          });
                        }
                      } catch (err) {
                        _iterator2.e(err);
                      } finally {
                        _iterator2.f();
                      }

                    case 61:
                      // endregion
                      // region handle build
                      buildConfigurations = _helper["default"].resolveBuildConfigurationFilePaths(_configurator["default"].buildContext.types, _configurator["default"].path.source.asset.base, _configurator["default"].path.ignore.concat(_configurator["default"].module.directoryNames, _configurator["default"].loader.directoryNames).map(function (filePath) {
                        return _path["default"].resolve(_configurator["default"].path.context, filePath);
                      }).filter(function (filePath) {
                        return !_configurator["default"].path.context.startsWith(filePath);
                      }), _configurator["default"]["package"].main.fileNames);

                      if (['build', 'build:dll', 'document', 'test'].includes(process.argv[2])) {
                        tidiedUp = false;

                        tidyUp = function tidyUp() {
                          /*
                              Determines all none javaScript entities which have been
                              emitted as single module to remove.
                          */
                          if (tidiedUp) return;
                          tidiedUp = true;

                          for (var chunkName in _configurator["default"].injection.entry.normalized) {
                            if (Object.prototype.hasOwnProperty.call(_configurator["default"].injection.entry.normalized, chunkName)) {
                              var _iterator3 = _createForOfIteratorHelper(_configurator["default"].injection.entry.normalized[chunkName]),
                                  _step3;

                              try {
                                for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                                  var moduleID = _step3.value;

                                  var _filePath2 = _helper["default"].determineModuleFilePath(moduleID, _configurator["default"].module.aliases, _configurator["default"].module.replacements.normal, {
                                    file: _configurator["default"].extensions.file.internal
                                  }, _configurator["default"].path.context, _configurator["default"].path.source.asset.base, _configurator["default"].path.ignore, _configurator["default"].module.directoryNames, _configurator["default"]["package"].main.fileNames, _configurator["default"]["package"].main.propertyNames, _configurator["default"]["package"].aliasPropertyNames, _configurator["default"].encoding);

                                  var type = null;
                                  if (_filePath2) type = _helper["default"].determineAssetType(_filePath2, _configurator["default"].buildContext.types, _configurator["default"].path);

                                  if (typeof type === 'string' && _configurator["default"].buildContext.types[type]) {
                                    var _filePath3 = _helper["default"].renderFilePathTemplate(_helper["default"].stripLoader(_configurator["default"].files.compose.javaScript), {
                                      '[name]': chunkName
                                    });
                                    /*
                                        NOTE: Close handler have to be
                                        synchronous.
                                    */


                                    if (_configurator["default"].buildContext.types[type].outputExtension === 'js' && _clientnode["default"].isFileSync(_filePath3)) _fs["default"].chmodSync(_filePath3, '755');
                                  }
                                }
                              } catch (err) {
                                _iterator3.e(err);
                              } finally {
                                _iterator3.f();
                              }
                            }
                          }

                          var _iterator4 = _createForOfIteratorHelper(_configurator["default"].path.tidyUp),
                              _step4;

                          try {
                            for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
                              var _filePath4 = _step4.value;
                              if (_filePath4) if (_clientnode["default"].isFileSync(_filePath4)) // NOTE: Close handler have to be synchronous.
                                _fs["default"].unlinkSync(_filePath4);else if (_clientnode["default"].isDirectorySync(_filePath4)) _rimraf["default"].sync(_filePath4, {
                                glob: false
                              });
                            }
                          } catch (err) {
                            _iterator4.e(err);
                          } finally {
                            _iterator4.f();
                          }
                        };

                        closeEventHandlers.push(tidyUp);
                        /*
                            Triggers complete asset compiling and bundles them into the
                            final productive output.
                        */

                        processPromises.push(new Promise(function (resolve, reject) {
                          var commandLineArguments = (_configurator["default"].commandLine.build.arguments || []).concat(additionalArguments);
                          console.info('Running "' + ("".concat(_configurator["default"].commandLine.build.command, " ") + commandLineArguments.join(' ')).trim() + '"');
                          var childProcess = (0, _child_process.spawn)(_configurator["default"].commandLine.build.command, commandLineArguments, childProcessOptions);

                          var copyAdditionalFilesAndTidyUp = function copyAdditionalFilesAndTidyUp() {
                            var _iterator5 = _createForOfIteratorHelper(_configurator["default"].files.additionalPaths),
                                _step5;

                            try {
                              for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                                var _filePath5 = _step5.value;

                                var sourcePath = _path["default"].join(_configurator["default"].path.source.base, _filePath5);

                                var targetPath = _path["default"].join(_configurator["default"].path.target.base, _filePath5); // NOTE: Close handler have to be synchronous.


                                if (_clientnode["default"].isDirectorySync(sourcePath)) {
                                  if (_clientnode["default"].isDirectorySync(targetPath)) _rimraf["default"].sync(targetPath, {
                                    glob: false
                                  });

                                  _clientnode["default"].copyDirectoryRecursiveSync(sourcePath, targetPath);
                                } else if (_clientnode["default"].isFileSync(sourcePath)) _clientnode["default"].copyFileSync(sourcePath, targetPath);
                              }
                            } catch (err) {
                              _iterator5.e(err);
                            } finally {
                              _iterator5.f();
                            }

                            tidyUp.apply(void 0, arguments);
                          };

                          var closeHandler = _clientnode["default"].getProcessCloseHandler(resolve, reject, null, process.argv[2] === 'build' ? copyAdditionalFilesAndTidyUp : tidyUp);

                          var _iterator6 = _createForOfIteratorHelper(_clientnode.CloseEventNames),
                              _step6;

                          try {
                            for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                              var closeEventName = _step6.value;
                              childProcess.on(closeEventName, closeHandler);
                            }
                          } catch (err) {
                            _iterator6.e(err);
                          } finally {
                            _iterator6.f();
                          }

                          childProcesses.push(childProcess);
                          return childProcesses;
                        })); // endregion
                        // region handle pre-install
                      } else if (_configurator["default"].library && _configurator["default"].givenCommandLineArguments[2] === 'preinstall') {
                        // Perform all file specific preprocessing stuff.
                        testModuleFilePaths = [];
                        if (_clientnode["default"].isPlainObject(_configurator["default"]['test:browser'].injection) && _configurator["default"]['test:browser'].injection.entry) testModuleFilePaths = _helper["default"].determineModuleLocations(_configurator["default"]['test:browser'].injection.entry, _configurator["default"].module.aliases, _configurator["default"].module.replacements.normal, {
                          file: _configurator["default"].extensions.file.internal
                        }, _configurator["default"].path.context, _configurator["default"].path.source.asset.base, _configurator["default"].path.ignore).filePaths;
                        _iterator7 = _createForOfIteratorHelper(buildConfigurations);

                        try {
                          for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
                            buildConfiguration = _step7.value;
                            expression = buildConfiguration[_configurator["default"].givenCommandLineArguments[2]].trim();
                            _iterator8 = _createForOfIteratorHelper(buildConfiguration.filePaths);

                            try {
                              for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
                                _filePath6 = _step8.value;

                                if (!testModuleFilePaths.includes(_filePath6)) {
                                  (function () {
                                    var evaluated = _clientnode["default"].stringEvaluate("`".concat(expression, "`"), {
                                      global: global,
                                      self: _configurator["default"],
                                      buildConfiguration: buildConfiguration,
                                      path: _path["default"],
                                      additionalArguments: additionalArguments,
                                      filePath: _filePath6
                                    });

                                    if (evaluated.error) throw new Error('Error occurred during processing given ' + "command: ".concat(evaluated.error));
                                    console.info("Running \"".concat(evaluated.result, "\""));
                                    processPromises.push(new Promise(function (resolve, reject) {
                                      return [_clientnode["default"].handleChildProcess((0, _child_process.exec)(evaluated.result, _clientnode["default"].extend({
                                        encoding: _configurator["default"].encoding
                                      }, processOptions), function (error) {
                                        return error ? reject(error) : resolve();
                                      }))];
                                    }));
                                  })();
                                }
                              }
                            } catch (err) {
                              _iterator8.e(err);
                            } finally {
                              _iterator8.f();
                            }
                          }
                        } catch (err) {
                          _iterator7.e(err);
                        } finally {
                          _iterator7.f();
                        }
                      } // endregion
                      // region handle remaining tasks


                      handleTask = function handleTask(type) {
                        var tasks = Array.isArray(_configurator["default"].commandLine[type]) ? _configurator["default"].commandLine[type] : [_configurator["default"].commandLine[type]];

                        var _iterator9 = _createForOfIteratorHelper(tasks),
                            _step9;

                        try {
                          var _loop = function _loop() {
                            var task = _step9.value;

                            var evaluated = _clientnode["default"].stringEvaluate(Object.prototype.hasOwnProperty.call(task, 'indicator') ? task.indicator : 'true', {
                              global: global,
                              self: _configurator["default"],
                              path: _path["default"]
                            });

                            if (evaluated.error) throw new Error('Error occurred during processing given task: ' + evaluated.error);
                            if (evaluated.result) processPromises.push(new Promise(function (resolve, reject) {
                              var commandLineArguments = (task.arguments || []).concat(additionalArguments);
                              console.info('Running "' + ("".concat(task.command, " ") + commandLineArguments.join(' ')).trim() + '"');
                              var childProcess = (0, _child_process.spawn)(task.command, commandLineArguments, childProcessOptions);

                              var closeHandler = _clientnode["default"].getProcessCloseHandler(resolve, reject);

                              var _iterator10 = _createForOfIteratorHelper(_clientnode.CloseEventNames),
                                  _step10;

                              try {
                                for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
                                  var closeEventName = _step10.value;
                                  childProcess.on(closeEventName, closeHandler);
                                }
                              } catch (err) {
                                _iterator10.e(err);
                              } finally {
                                _iterator10.f();
                              }

                              childProcesses.push(childProcess);
                              return childProcesses;
                            }));
                          };

                          for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
                            _loop();
                          }
                        } catch (err) {
                          _iterator9.e(err);
                        } finally {
                          _iterator9.f();
                        }
                      }; // / region a-/synchronous


                      if (!['document', 'test'].includes(_configurator["default"].givenCommandLineArguments[2])) {
                        _context2.next = 70;
                        break;
                      }

                      _context2.next = 67;
                      return Promise.all(processPromises);

                    case 67:
                      handleTask(_configurator["default"].givenCommandLineArguments[2]);
                      _context2.next = 71;
                      break;

                    case 70:
                      if (['check:types', 'lint', 'serve', 'test:browser'].includes(_configurator["default"].givenCommandLineArguments[2])) handleTask(_configurator["default"].givenCommandLineArguments[2]);

                    case 71:
                      finished = false;

                      closeHandler = function closeHandler() {
                        if (!finished) {
                          var _iterator11 = _createForOfIteratorHelper(closeEventHandlers),
                              _step11;

                          try {
                            for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
                              var closeEventHandler = _step11.value;
                              closeEventHandler.apply(void 0, arguments);
                            }
                          } catch (err) {
                            _iterator11.e(err);
                          } finally {
                            _iterator11.f();
                          }
                        }

                        finished = true;
                      };

                      _iterator12 = _createForOfIteratorHelper(_clientnode.CloseEventNames);

                      try {
                        for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
                          closeEventName = _step12.value;
                          // @ts-ignore: Accepts only "NodeSignals" but other strings are
                          // available.
                          process.on(closeEventName, closeHandler);
                        }
                      } catch (err) {
                        _iterator12.e(err);
                      } finally {
                        _iterator12.f();
                      }

                      if (require.main === module && (_configurator["default"].givenCommandLineArguments.length < 3 || !possibleArguments.includes(_configurator["default"].givenCommandLineArguments[2]))) console.info("Give one of \"".concat(possibleArguments.join('", "'), "\" as command ") + 'line argument. You can provide a json string as second ' + 'parameter to dynamically overwrite some configurations.\n'); // endregion
                      // region forward nested return codes

                      _context2.prev = 76;
                      _context2.next = 79;
                      return Promise.all(processPromises);

                    case 79:
                      _context2.next = 84;
                      break;

                    case 81:
                      _context2.prev = 81;
                      _context2.t3 = _context2["catch"](76);
                      process.exit(_context2.t3.returnCode);

                    case 84:
                    case "end":
                      return _context2.stop();
                  }
                }
              }, _callee2, null, [[33, 44, 47, 50], [76, 81]]);
            })(), "t0", 2);

          case 2:
            _context3.next = 11;
            break;

          case 4:
            _context3.prev = 4;
            _context3.t1 = _context3["catch"](0);

            if (!_configurator["default"].debug) {
              _context3.next = 10;
              break;
            }

            throw _context3.t1;

          case 10:
            console.error(_context3.t1);

          case 11:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[0, 4]]);
  }));

  return function main() {
    return _ref.apply(this, arguments);
  };
}();

if (require.main === module) main();
var _default = main; // region vim modline
// vim: set tabstop=4 shiftwidth=4 expandtab:
// vim: foldmethod=marker foldmarker=region,endregion:
// endregion

exports["default"] = _default;
