// #!/usr/bin/env babel-node
// -*- coding: utf-8 -*-

/** @module webpackConfigurator */
'use strict';
/* !
    region header
    Copyright Torben Sickert (info["~at~"]torben.website) 16.12.2012

    License
    -------

    This library written by Torben Sickert stand under a creative commons
    naming 3.0 unported license.
    See https://creativecommons.org/licenses/by/3.0/deed.de
    endregion
*/
// region imports

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.webpackConfiguration = void 0;

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _clientnode = _interopRequireWildcard(require("clientnode"));

var _jsdom = require("jsdom");

var _fs = require("fs");

var _path2 = _interopRequireDefault(require("path"));

var _util = _interopRequireDefault(require("util"));

var _webpack = _interopRequireWildcard(require("webpack"));

var _webpackSources = require("webpack-sources");

var _ejsLoader = _interopRequireDefault(require("./ejsLoader"));

var _configurator = _interopRequireDefault(require("./configurator"));

var _helper = _interopRequireDefault(require("./helper"));

var _htmlLoader = _interopRequireDefault(require("html-loader"));

var _loaderUtils = _interopRequireDefault(require("loader-utils"));

var _configuration$path$c, _configuration$cache, _configuration$cache2, _configuration$path$c2;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var postcssCSSnano = (0, _clientnode.optionalRequire)('cssnano');
var postcssFontPath = (0, _clientnode.optionalRequire)('postcss-fontpath');
var postcssImport = (0, _clientnode.optionalRequire)('postcss-import');
var postcssSprites = (0, _clientnode.optionalRequire)('postcss-sprites');
var postcssURL = (0, _clientnode.optionalRequire)('postcss-url');
var pluginNameResourceMapping = {
  HTML: 'html-webpack-plugin',
  MiniCSSExtract: 'mini-css-extract-plugin',
  AddAssetHTMLPlugin: 'add-asset-html-webpack-plugin',
  Favicon: 'favicons-webpack-plugin',
  Imagemin: 'imagemin-webpack-plugin',
  Offline: 'offline-plugin'
};
var plugins = {};

for (var name in pluginNameResourceMapping) {
  if (Object.prototype.hasOwnProperty.call(pluginNameResourceMapping, name)) try {
    plugins[name] = require(pluginNameResourceMapping[name]);
  } catch (error) {
    console.debug("Optional webpack plugin \"".concat(name, "\" not available."));
  }
}

if (plugins.Imagemin) plugins.Imagemin = plugins.Imagemin["default"];
if (require.cache && require.resolve('html-loader') in require.cache) require.cache[require.resolve('html-loader')].exports = function () {
  _clientnode["default"].extend(true, this.options, module, this.options);

  for (var _len = arguments.length, parameter = new Array(_len), _key = 0; _key < _len; _key++) {
    parameter[_key] = arguments[_key];
  }

  return _htmlLoader["default"].call.apply(_htmlLoader["default"], [this].concat(parameter));
}; // Monkey-Patch loader-utils to define which url is a local request.

var loaderUtilsIsUrlRequestBackup = _loaderUtils["default"].isUrlRequest;
if (require.cache && require.resolve('loader-utils') in require.cache) require.cache[require.resolve('loader-utils')].exports.isUrlRequest = function (url) {
  if (/^[a-z]+:.+/.exec(url)) return false;

  for (var _len2 = arguments.length, parameter = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    parameter[_key2 - 1] = arguments[_key2];
  }

  return loaderUtilsIsUrlRequestBackup.call.apply(loaderUtilsIsUrlRequestBackup, [_loaderUtils["default"], url].concat(parameter));
}; // / endregion
// endregion
// region initialisation
// / region determine library name

var libraryName;
if (_configurator["default"].libraryName) libraryName = _configurator["default"].libraryName;else if (Object.keys(_configurator["default"].injection.entry.normalized).length > 1) libraryName = '[name]';else {
  libraryName = _configurator["default"].name;
  if (['assign', 'global', 'this', 'var', 'window'].includes(_configurator["default"].exportFormat.self)) libraryName = _clientnode["default"].stringConvertToValidVariableName(libraryName);
} // / endregion
// / region plugins

var pluginInstances = []; // // region define modules to ignore

var _iterator = _createForOfIteratorHelper([].concat(_configurator["default"].injection.ignorePattern)),
    _step;

try {
  for (_iterator.s(); !(_step = _iterator.n()).done;) {
    var pattern = _step.value;
    if (typeof pattern.contextRegExp === 'string') pattern.contextRegExp = new RegExp(pattern.contextRegExp);
    if (typeof pattern.resourceRegExp === 'string') pattern.resourceRegExp = new RegExp(pattern.resourceRegExp);
    pluginInstances.push(new _webpack.IgnorePlugin(pattern));
  } // // endregion
  // // region define modules to replace

} catch (err) {
  _iterator.e(err);
} finally {
  _iterator.f();
}

var _loop = function _loop(source) {
  if (Object.prototype.hasOwnProperty.call(_configurator["default"].module.replacements.normal, source)) {
    var search = new RegExp(source);
    pluginInstances.push(new _webpack.NormalModuleReplacementPlugin(search, function (resource) {
      resource.request = resource.request.replace( // @ts-ignore: https://github.com/microsoft/TypeScript/
      // issues/22378
      search, _configurator["default"].module.replacements.normal[source]);
    }));
  }
};

for (var source in _configurator["default"].module.replacements.normal) {
  _loop(source);
} // // endregion
// // region generate html file


var htmlAvailable = false;

if (_configurator["default"].givenCommandLineArguments[2] !== 'build:dll') {
  var _iterator2 = _createForOfIteratorHelper(_configurator["default"].files.html),
      _step2;

  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var htmlConfiguration = _step2.value;

      if (_clientnode["default"].isFileSync(htmlConfiguration.template.filePath)) {
        pluginInstances.push(new plugins.HTML(_objectSpread(_objectSpread({}, htmlConfiguration), {}, {
          template: htmlConfiguration.template.request
        })));
        htmlAvailable = true;
      }
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
} // // endregion
// // region generate favicons


if (htmlAvailable && _configurator["default"].favicon && plugins.Favicon && _clientnode["default"].isFileSync(_configurator["default"].favicon.logo)) pluginInstances.push(new plugins.Favicon(_configurator["default"].favicon)); // // endregion
// // region provide offline functionality

if (htmlAvailable && _configurator["default"].offline && plugins.Offline) {
  if (!['serve', 'test:browser'].includes(_configurator["default"].givenCommandLineArguments[2])) for (var _i = 0, _Object$entries = Object.entries({
    cascadingStyleSheet: 'css',
    javaScript: 'js'
  }); _i < _Object$entries.length; _i++) {
    var _Object$entries$_i = (0, _slicedToArray2["default"])(_Object$entries[_i], 2),
        _name = _Object$entries$_i[0],
        extension = _Object$entries$_i[1];

    var type = _name;

    if (_configurator["default"].inPlace[type]) {
      var matches = Object.keys(_configurator["default"].inPlace[type]);

      for (var _i2 = 0, _matches = matches; _i2 < _matches.length; _i2++) {
        var _name2 = _matches[_i2];

        _configurator["default"].offline.excludes.push(_path2["default"].relative(_configurator["default"].path.target.base, _configurator["default"].path.target.asset[type]) + "".concat(_name2, ".").concat(extension, "?").concat(_configurator["default"].hashAlgorithm, "=*"));
      }
    }
  }
  pluginInstances.push(new plugins.Offline(_configurator["default"].offline));
} // // endregion
// // region provide build environment


if (_configurator["default"].buildContext.definitions) pluginInstances.push(new _webpack.DefinePlugin(_configurator["default"].buildContext.definitions));
if (_configurator["default"].module.provide) pluginInstances.push(new _webpack.ProvidePlugin(_configurator["default"].module.provide)); // // endregion
// // region modules/assets
// /// region apply module pattern

pluginInstances.push({
  apply: function apply(compiler) {
    compiler.hooks.emit.tap('applyModulePattern', function (compilation) {
      for (var request in compilation.assets) {
        if (Object.prototype.hasOwnProperty.call(compilation.assets, request)) {
          var filePath = request.replace(/\?[^?]+$/, '');

          var _type = _helper["default"].determineAssetType(filePath, _configurator["default"].buildContext.types, _configurator["default"].path);

          if (_type && _configurator["default"].assetPattern[_type] && new RegExp(_configurator["default"].assetPattern[_type].includeFilePathRegularExpression).test(filePath) && !new RegExp(_configurator["default"].assetPattern[_type].excludeFilePathRegularExpression).test(filePath)) {
            var _source = compilation.assets[request].source();

            if (typeof _source === 'string') compilation.assets[request] = new _webpackSources.RawSource(_configurator["default"].assetPattern[_type].pattern.replace(/\{1\}/g, _source.replace(/\$/g, '$$$')));
          }
        }
      }
    });
  }
}); // /// endregion
// /// region in-place configured assets in the main html file

if (htmlAvailable && !['serve', 'test:browser'].includes(_configurator["default"].givenCommandLineArguments[2])) pluginInstances.push({
  apply: function apply(compiler) {
    var filePathsToRemove = [];
    compiler.hooks.compilation.tap('inPlaceHTMLAssets', function (compilation) {
      return compilation.hooks.htmlWebpackPluginAfterHtmlProcessing.tapAsync('inPlaceHTMLAssets', function (data, callback) {
        if (_configurator["default"].inPlace.cascadingStyleSheet && Object.keys(_configurator["default"].inPlace.cascadingStyleSheet).length || _configurator["default"].inPlace.javaScript && Object.keys(_configurator["default"].inPlace.javaScript).length) try {
          var result = _helper["default"].inPlaceCSSAndJavaScriptAssetReferences(data.html, _configurator["default"].inPlace.cascadingStyleSheet, _configurator["default"].inPlace.javaScript, _configurator["default"].path.target.base, _configurator["default"].files.compose.cascadingStyleSheet, _configurator["default"].files.compose.javaScript, compilation.assets);

          data.html = result.content;
          filePathsToRemove.concat(result.filePathsToRemove);
        } catch (error) {
          return callback(error, data);
        }
        callback(null, data);
      });
    });
    compiler.hooks.afterEmit.tapAsync('removeInPlaceHTMLAssetFiles', /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(data, callback) {
        var promises, _iterator3, _step3, _path, _loop2, _i3, _arr;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                promises = [];
                _iterator3 = _createForOfIteratorHelper(filePathsToRemove);
                _context2.prev = 2;

                _iterator3.s();

              case 4:
                if ((_step3 = _iterator3.n()).done) {
                  _context2.next = 12;
                  break;
                }

                _path = _step3.value;
                _context2.next = 8;
                return _clientnode["default"].isFile(_path);

              case 8:
                if (!_context2.sent) {
                  _context2.next = 10;
                  break;
                }

                promises.push(_fs.promises.unlink(_path)["catch"](console.error));

              case 10:
                _context2.next = 4;
                break;

              case 12:
                _context2.next = 17;
                break;

              case 14:
                _context2.prev = 14;
                _context2.t0 = _context2["catch"](2);

                _iterator3.e(_context2.t0);

              case 17:
                _context2.prev = 17;

                _iterator3.f();

                return _context2.finish(17);

              case 20:
                _context2.next = 22;
                return Promise.all(promises);

              case 22:
                promises = [];

                _loop2 = function _loop2() {
                  var type = _arr[_i3];
                  promises.push(_fs.promises.readdir(type, {
                    encoding: _configurator["default"].encoding
                  }).then( /*#__PURE__*/function () {
                    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(files) {
                      return _regenerator["default"].wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              if (!(files.length === 0)) {
                                _context.next = 3;
                                break;
                              }

                              _context.next = 3;
                              return _fs.promises.rmdir(type);

                            case 3:
                            case "end":
                              return _context.stop();
                          }
                        }
                      }, _callee);
                    }));

                    return function (_x3) {
                      return _ref2.apply(this, arguments);
                    };
                  }()));
                };

                for (_i3 = 0, _arr = [_configurator["default"].path.target.asset.javaScript, _configurator["default"].path.target.asset.cascadingStyleSheet]; _i3 < _arr.length; _i3++) {
                  _loop2();
                }

                _context2.next = 27;
                return Promise.all(promises);

              case 27:
                callback();

              case 28:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[2, 14, 17, 20]]);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
  }
}); // /// endregion
// /// region remove chunks if a corresponding dll package exists

if (_configurator["default"].givenCommandLineArguments[2] !== 'build:dll') for (var chunkName in _configurator["default"].injection.entry.normalized) {
  if (Object.prototype.hasOwnProperty.call(_configurator["default"].injection.entry.normalized, chunkName)) {
    var manifestFilePath = "".concat(_configurator["default"].path.target.base, "/").concat(chunkName, ".") + "dll-manifest.json";

    if (_configurator["default"].dllManifestFilePaths.includes(manifestFilePath)) {
      delete _configurator["default"].injection.entry.normalized[chunkName];

      var filePath = _helper["default"].renderFilePathTemplate(_helper["default"].stripLoader(_configurator["default"].files.compose.javaScript), {
        '[name]': chunkName
      });

      pluginInstances.push(new plugins.AddAssetHTMLPlugin({
        filepath: filePath,
        hash: true,
        includeSourcemap: _clientnode["default"].isFileSync("".concat(filePath, ".map"))
      }));
      pluginInstances.push(new _webpack.DllReferencePlugin({
        context: _configurator["default"].path.context,
        manifest: require(manifestFilePath)
      }));
    }
  }
} // /// endregion
// /// region mark empty javaScript modules as dummy

if (!(_configurator["default"].needed.javaScript || _configurator["default"].needed.javaScriptExtension || _configurator["default"].needed.typeScript || _configurator["default"].needed.typeScriptExtension)) _configurator["default"].files.compose.javaScript = _path2["default"].resolve(_configurator["default"].path.target.asset.javaScript, '.__dummy__.compiled.js'); // /// endregion
// /// region extract cascading style sheets

if (_configurator["default"].files.compose.cascadingStyleSheet && plugins.MiniCSSExtract) pluginInstances.push(new plugins.MiniCSSExtract({
  filename: _path2["default"].relative(_configurator["default"].path.target.base, _configurator["default"].files.compose.cascadingStyleSheet)
})); // /// endregion
// /// region performs implicit external logic

if (_configurator["default"].injection.external.modules === '__implicit__')
  /*
      We only want to process modules from local context in library mode,
      since a concrete project using this library should combine all assets
      (and de-duplicate them) for optimal bundling results.
      NOTE: Only native java script and json modules will be marked as
      external dependency.
  */
  _configurator["default"].injection.external.modules = function (context, request, callback) {
    request = request.replace(/^!+/, '');
    if (request.startsWith('/')) request = _path2["default"].relative(_configurator["default"].path.context, request);

    var _iterator4 = _createForOfIteratorHelper(_configurator["default"].module.directoryNames),
        _step4;

    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var _filePath = _step4.value;

        if (request.startsWith(_filePath)) {
          request = request.substring(_filePath.length);
          if (request.startsWith('/')) request = request.substring(1);
          break;
        }
      } // region pattern based aliasing

    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }

    var filePath = _helper["default"].determineModuleFilePath(request, {}, {}, {
      file: _configurator["default"].extensions.file.external
    }, _configurator["default"].path.context, context, _configurator["default"].path.ignore, _configurator["default"].module.directoryNames, _configurator["default"]["package"].main.fileNames, _configurator["default"]["package"].main.propertyNames, _configurator["default"]["package"].aliasPropertyNames, _configurator["default"].encoding);

    if (filePath) for (var pattern in _configurator["default"].injection.external.aliases) {
      if (Object.prototype.hasOwnProperty.call(_configurator["default"].injection.external.aliases, pattern) && pattern.startsWith('^')) {
        var regularExpression = new RegExp(pattern);

        if (regularExpression.test(filePath)) {
          var match = false;
          var targetConfiguration = _configurator["default"].injection.external.aliases[pattern];
          if (typeof targetConfiguration !== 'string') break;
          var replacementRegularExpression = new RegExp(Object.keys(targetConfiguration)[0]);
          var target = targetConfiguration[Object.keys(targetConfiguration)[0]];

          if (target.startsWith('?')) {
            target = target.substring(1);
            var aliasedRequest = request.replace(replacementRegularExpression, target);
            if (aliasedRequest !== request) match = Boolean(_helper["default"].determineModuleFilePath(aliasedRequest, {}, {}, {
              file: _configurator["default"].extensions.file.external
            }, _configurator["default"].path.context, context, _configurator["default"].path.ignore, _configurator["default"].module.directoryNames, _configurator["default"]["package"].main.fileNames, _configurator["default"]["package"].main.propertyNames, _configurator["default"]["package"].aliasPropertyNames, _configurator["default"].encoding));
          } else match = true;

          if (match) {
            request = request.replace(replacementRegularExpression, target);
            break;
          }
        }
      }
    } // endregion

    var resolvedRequest = _helper["default"].determineExternalRequest(request, _configurator["default"].path.context, context, _configurator["default"].injection.entry.normalized, _configurator["default"].module.directoryNames, _configurator["default"].module.aliases, _configurator["default"].module.replacements.normal, _configurator["default"].extensions, _configurator["default"].path.source.asset.base, _configurator["default"].path.ignore, _configurator["default"].module.directoryNames, _configurator["default"]["package"].main.fileNames, _configurator["default"]["package"].main.propertyNames, _configurator["default"]["package"].aliasPropertyNames, _configurator["default"].injection.external.implicit.pattern.include, _configurator["default"].injection.external.implicit.pattern.exclude, _configurator["default"].inPlace.externalLibrary.normal, _configurator["default"].inPlace.externalLibrary.dynamic, _configurator["default"].encoding);

    if (resolvedRequest) {
      var keys = ['amd', 'commonjs', 'commonjs2', 'root'];
      var result = resolvedRequest;

      if (Object.prototype.hasOwnProperty.call(_configurator["default"].injection.external.aliases, request)) {
        // region normal alias replacement
        result = {
          "default": request
        };

        if (typeof _configurator["default"].injection.external.aliases[request] === 'string') {
          var _iterator5 = _createForOfIteratorHelper(keys),
              _step5;

          try {
            for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
              var key = _step5.value;
              result[key] = _configurator["default"].injection.external.aliases[request];
            }
          } catch (err) {
            _iterator5.e(err);
          } finally {
            _iterator5.f();
          }
        } else if (typeof _configurator["default"].injection.external.aliases[request] === 'function') {
          var _iterator6 = _createForOfIteratorHelper(keys),
              _step6;

          try {
            for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
              var _key3 = _step6.value;
              result[_key3] = _configurator["default"].injection.external.aliases[request](request, _key3);
            }
          } catch (err) {
            _iterator6.e(err);
          } finally {
            _iterator6.f();
          }
        } else if (_configurator["default"].injection.external.aliases[request] !== null && (0, _typeof2["default"])(_configurator["default"].injection.external.aliases[request]) === 'object') _clientnode["default"].extend(result, _configurator["default"].injection.external.aliases[request]);

        if (Object.prototype.hasOwnProperty.call(result, 'default')) {
          var _iterator7 = _createForOfIteratorHelper(keys),
              _step7;

          try {
            for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
              var _key4 = _step7.value;
              if (!Object.prototype.hasOwnProperty.call(result, _key4)) result[_key4] = result["default"];
            }
          } catch (err) {
            _iterator7.e(err);
          } finally {
            _iterator7.f();
          }
        } // endregion

      }

      if (typeof result !== 'string' && Object.prototype.hasOwnProperty.call(result, 'root')) result.root = [].concat(result.root).map(function (name) {
        return _clientnode["default"].stringConvertToValidVariableName(name);
      });
      var exportFormat = _configurator["default"].exportFormat.external || _configurator["default"].exportFormat.self;
      return callback(null, exportFormat === 'umd' || typeof result === 'string' ? result : result[exportFormat], exportFormat);
    }

    return callback();
  }; // /// endregion
// /// region build dll packages

if (_configurator["default"].givenCommandLineArguments[2] === 'build:dll') {
  var dllChunkExists = false;

  for (var _chunkName in _configurator["default"].injection.entry.normalized) {
    if (Object.prototype.hasOwnProperty.call(_configurator["default"].injection.entry.normalized, _chunkName)) if (_configurator["default"].injection.dllChunkNames.includes(_chunkName)) dllChunkExists = true;else delete _configurator["default"].injection.entry.normalized[_chunkName];
  }

  if (dllChunkExists) {
    libraryName = '[name]DLLPackage';
    pluginInstances.push(new _webpack.DllPlugin({
      name: libraryName,
      path: "".concat(_configurator["default"].path.target.base, "/[name].dll-manifest.json")
    }));
  } else console.warn('No dll chunk id found.');
} // /// endregion
// // endregion
// // region apply final dom/javaScript/cascadingStyleSheet modifications/fixes


if (htmlAvailable) pluginInstances.push({
  apply: function apply(compiler) {
    return compiler.hooks.compilation.tap('WebOptimizer', function (compilation) {
      plugins.HTML.getHooks(compilation).alterAssetTagGroups.tapAsync('WebOptimizerRemoveDummyHTMLTags', function (data, callback) {
        for (var _i4 = 0, _arr2 = [data.bodyTags, data.headTags]; _i4 < _arr2.length; _i4++) {
          var tags = _arr2[_i4];
          var index = 0;

          var _iterator8 = _createForOfIteratorHelper(tags),
              _step8;

          try {
            for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
              var tag = _step8.value;
              if (/^\.__dummy__(\..*)?$/.test(_path2["default"].basename(tag.attributes.src || tag.attributes.href || ''))) tags.splice(index, 1);
              index += 1;
            }
          } catch (err) {
            _iterator8.e(err);
          } finally {
            _iterator8.f();
          }
        }

        callback(null, data);
      });
      plugins.HTML.getHooks(compilation).beforeEmit.tapAsync('WebOptimizerPostProcessHTML', function (data, callback) {
        /*
            NOTE: We have to prevent creating native "style" dom nodes
            to prevent jsdom from parsing the entire cascading style
            sheet. Which is error prune and very resource intensive.
        */
        var styleContents = [];
        data.html = data.html.replace(/(<style[^>]*>)([\s\S]*?)(<\/style[^>]*>)/gi, function (match, startTag, content, endTag) {
          styleContents.push(content);
          return "".concat(startTag).concat(endTag);
        });
        var dom;

        try {
          /*
              NOTE: We have to translate template delimiter to html
              compatible sequences and translate it back later to
              avoid unexpected escape sequences in resulting html.
          */
          dom = new _jsdom.JSDOM(data.html.replace(/<%/g, '##+#+#+##').replace(/%>/g, '##-#-#-##'));
        } catch (error) {
          return callback(error, data);
        }

        var linkables = {
          link: 'href',
          script: 'src'
        };

        for (var tagName in linkables) {
          if (Object.prototype.hasOwnProperty.call(linkables, tagName)) for (var _i5 = 0, _Array$from = Array.from(dom.window.document.querySelectorAll("".concat(tagName, "[").concat(linkables[tagName], "*=\"?") + "".concat(_configurator["default"].hashAlgorithm, "=\"]"))); _i5 < _Array$from.length; _i5++) {
            var domNode = _Array$from[_i5];

            /*
                NOTE: Removing symbols after a "&" in hash
                string is necessary to match the generated
                request strings in offline plugin.
            */
            domNode.setAttribute(linkables[tagName], // @ts-ignore: Typescripts wrongly considers
            // "null".
            domNode.getAttribute(linkables[tagName]).replace(new RegExp('(\\?' + "".concat(_configurator["default"].hashAlgorithm, "=") + '[^&]+).*$'), '$1'));
          }
        }
        /*
            NOTE: We have to restore template delimiter and style
            contents.
        */


        data.html = dom.serialize().replace(/##\+#\+#\+##/g, '<%').replace(/##-#-#-##/g, '%>').replace(/(<style[^>]*>)[\s\S]*?(<\/style[^>]*>)/gi, function (match, startTag, endTag) {
          return "".concat(startTag).concat(styleContents.shift()).concat(endTag);
        }); // region post compilation

        var _iterator9 = _createForOfIteratorHelper(_configurator["default"].files.html),
            _step9;

        try {
          for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
            var htmlFileSpecification = _step9.value;

            if (htmlFileSpecification.filename === data.plugin.options.filename) {
              var _iterator10 = _createForOfIteratorHelper(Array.isArray(htmlFileSpecification.template.use) ? htmlFileSpecification.template.use : [htmlFileSpecification.template.use]),
                  _step10;

              try {
                for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
                  var _loaderConfiguration$;

                  var loaderConfiguration = _step10.value;
                  if ((_loaderConfiguration$ = loaderConfiguration.options) !== null && _loaderConfiguration$ !== void 0 && _loaderConfiguration$.compileSteps && typeof loaderConfiguration.options.compileSteps === 'number') data.html = _ejsLoader["default"].bind(_clientnode["default"].extend(true, {}, {
                    options: loaderConfiguration.options || {}
                  }, {
                    options: {
                      compileSteps: htmlFileSpecification.template.postCompileSteps
                    }
                  }))(data.html);
                }
              } catch (err) {
                _iterator10.e(err);
              } finally {
                _iterator10.f();
              }

              break;
            }
          } // endregion

        } catch (err) {
          _iterator9.e(err);
        } finally {
          _iterator9.f();
        }

        callback(null, data);
      });
    });
  }
}); // // endregion
// // region add automatic image compression
// NOTE: This plugin should be loaded at last to ensure that all emitted images
// ran through.

if (plugins.Imagemin) pluginInstances.push(new plugins.Imagemin(_configurator["default"].module.optimizer.image.content)); // // endregion
// // region context replacements

var _iterator11 = _createForOfIteratorHelper(_configurator["default"].module.replacements.context),
    _step11;

try {
  for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
    var contextReplacement = _step11.value;
    pluginInstances.push((0, _construct2["default"])(_webpack.ContextReplacementPlugin, (0, _toConsumableArray2["default"])(contextReplacement.map(function (value) {
      var evaluated = _clientnode["default"].stringEvaluate(value, {
        configuration: _configurator["default"],
        __dirname: __dirname,
        __filename: __filename
      });

      if (evaluated.compileError || evaluated.runtimeError) throw new Error('Error occurred during processing given context ' + 'replacement: ' + evaluated.compileError || evaluated.runtimeError);
      return evaluated.result;
    }))));
  } // // endregion
  // // region consolidate duplicated module requests

} catch (err) {
  _iterator11.e(err);
} finally {
  _iterator11.f();
}

pluginInstances.push({
  apply: function apply(compiler) {
    return compiler.hooks.normalModuleFactory.tap('WebOptimizerModuleConsolidation', function (nmf) {
      return nmf.hooks.afterResolve.tap('WebOptimizerModuleConsolidation', function (result) {
        var targetPath = result.createData.resource;

        if (targetPath && /((?:^|\/)node_modules\/.+){2}/.test(targetPath) && _clientnode["default"].isFileSync(targetPath)) {
          var packageDescriptor = _helper["default"].getClosestPackageDescriptor(targetPath);

          if (packageDescriptor) {
            var pathPrefixes = targetPath.match(/((?:^|.*?\/)node_modules\/)/g);
            if (pathPrefixes === null) return; // Avoid finding the same artefact.

            pathPrefixes.pop();
            var index = 0;

            var _iterator12 = _createForOfIteratorHelper(pathPrefixes),
                _step12;

            try {
              for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
                var pathPrefix = _step12.value;
                if (index > 0) pathPrefixes[index] = _path2["default"].resolve(pathPrefixes[index - 1], pathPrefix);
                index += 1;
              }
            } catch (err) {
              _iterator12.e(err);
            } finally {
              _iterator12.f();
            }

            var pathSuffix = targetPath.replace(/(?:^|.*\/)node_modules\/(.+$)/, '$1');
            var redundantRequest = null;

            var _iterator13 = _createForOfIteratorHelper(pathPrefixes),
                _step13;

            try {
              for (_iterator13.s(); !(_step13 = _iterator13.n()).done;) {
                var _pathPrefix = _step13.value;

                var alternateTargetPath = _path2["default"].resolve(_pathPrefix, pathSuffix);

                if (_clientnode["default"].isFileSync(alternateTargetPath)) {
                  var otherPackageDescriptor = _helper["default"].getClosestPackageDescriptor(alternateTargetPath);

                  if (otherPackageDescriptor) {
                    if (packageDescriptor.configuration.version === otherPackageDescriptor.configuration.version) {
                      console.info('\nConsolidate module request "' + "".concat(targetPath, "\" to \"") + "".concat(alternateTargetPath, "\"."));
                      /*
                          NOTE: Only overwriting
                          "result.createData.resource" like
                          implemented in
                          "NormaleModuleReplacementPlugin" does
                          not always work.
                      */

                      result.request = result.createData.request = result.createData.resource = result.createData.userRequest = result.createData.rawRequest = alternateTargetPath;
                      return;
                    }

                    redundantRequest = {
                      path: alternateTargetPath,
                      version: otherPackageDescriptor.configuration.version
                    };
                  }
                }
              }
            } catch (err) {
              _iterator13.e(err);
            } finally {
              _iterator13.f();
            }

            if (redundantRequest) console.warn('\nIncluding different versions of same package "' + "".concat(packageDescriptor.configuration.name, "\". Module \"") + "".concat(targetPath, "\" (version ") + "".concat(packageDescriptor.configuration.version, ") has ") + "redundancies with \"".concat(redundantRequest.path, "\" (") + "version ".concat(redundantRequest.version, ")."));
          }
        }
      });
    });
  }
});
/*
new NormalModuleReplacementPlugin(
    /.+/,
    (result:{
        context:string
        createData:{resource:string}
        request:string
    }):void => {
        const isResource:boolean = Boolean(result.createData.resource)
        const targetPath:string = isResource ?
            result.createData.resource :
            path.resolve(result.context, result.request)
        if (
            targetPath &&
            /((?:^|\/)node_modules\/.+){2}/.test(targetPath) &&
            Tools.isFileSync(targetPath)
        ) {
            const packageDescriptor:null|PackageDescriptor =
                Helper.getClosestPackageDescriptor(targetPath)
            if (packageDescriptor) {
                const pathPrefixes:null|RegExpMatchArray = targetPath.match(
                    /((?:^|.*?\/)node_modules\/)/g
                )
                if (pathPrefixes === null)
                    return
                // Avoid finding the same artefact.
                pathPrefixes.pop()
                let index:number = 0
                for (const pathPrefix of pathPrefixes) {
                    if (index > 0)
                        pathPrefixes[index] =
                            path.resolve(pathPrefixes[index - 1], pathPrefix)
                    index += 1
                }
                const pathSuffix:string =
                    targetPath.replace(/(?:^|.*\/)node_modules\/(.+$)/, '$1')
                let redundantRequest:null|PlainObject = null
                for (const pathPrefix of pathPrefixes) {
                    const alternateTargetPath:string =
                        path.resolve(pathPrefix, pathSuffix)
                    if (Tools.isFileSync(alternateTargetPath)) {
                        const otherPackageDescriptor:null|PackageDescriptor =
                            Helper.getClosestPackageDescriptor(
                                alternateTargetPath
                            )
                        if (otherPackageDescriptor) {
                            if (
                                packageDescriptor.configuration.version ===
                                otherPackageDescriptor.configuration.version
                            ) {
                                console.info(
                                    '\nConsolidate module request "' +
                                    `${targetPath}" to "` +
                                    `${alternateTargetPath}".`
                                )
                                result.createData.resource =
                                    alternateTargetPath
                                result.request = alternateTargetPath
                                return
                            }
                            redundantRequest = {
                                path: alternateTargetPath,
                                version:
                                    otherPackageDescriptor.configuration
                                        .version
                            }
                        }
                    }
                }
                if (redundantRequest)
                    console.warn(
                        '\nIncluding different versions of same package "' +
                        `${packageDescriptor.configuration.name}". Module "` +
                        `${targetPath}" (version ` +
                        `${packageDescriptor.configuration.version}) has ` +
                        `redundancies with "${redundantRequest.path}" (` +
                        `version ${redundantRequest.version}).`
                    )
            }
        }
    }
))*/
// // endregion
// / endregion
// / region loader helper

var isFilePathInDependencies = function isFilePathInDependencies(filePath) {
  filePath = _helper["default"].stripLoader(filePath);
  return _helper["default"].isFilePathInLocation(filePath, _configurator["default"].path.ignore.concat(_configurator["default"].module.directoryNames, _configurator["default"].loader.directoryNames).map(function (filePath) {
    return _path2["default"].resolve(_configurator["default"].path.context, filePath);
  }).filter(function (filePath) {
    return !_configurator["default"].path.context.startsWith(filePath);
  }));
};

var loader = {};
var scope = {
  configuration: _configurator["default"],
  isFilePathInDependencies: isFilePathInDependencies,
  loader: loader,
  require: eval('require')
};

var evaluate = function evaluate(object) {
  var filePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _configurator["default"].path.context;

  if (typeof object === 'string') {
    var evaluated = _clientnode["default"].stringEvaluate(object, _objectSpread({
      filePath: filePath
    }, scope));

    if (evaluated.compileError || evaluated.runtimeError) throw new Error('Error occurred during processing given expression: ' + evaluated.compileError || evaluated.runtimeError);
    return evaluated.result;
  }

  return object;
};

var evaluateMapper = function evaluateMapper(value) {
  return evaluate(value);
};

var evaluateAdditionalLoaderConfiguration = function evaluateAdditionalLoaderConfiguration(loaderConfiguration) {
  return {
    exclude: function exclude(filePath) {
      return evaluate(loaderConfiguration.exclude || false, filePath);
    },
    include: loaderConfiguration.include && evaluate(loaderConfiguration.include) || _configurator["default"].path.source.base,
    test: new RegExp(evaluate(loaderConfiguration.test)),
    use: evaluate(loaderConfiguration.use)
  };
};

var includingPaths = _helper["default"].normalizePaths([_configurator["default"].path.source.asset.javaScript].concat(_configurator["default"].module.locations.directoryPaths));

_clientnode["default"].extend(loader, {
  // Convert to compatible native web types.
  // region generic template
  ejs: {
    exclude: function exclude(filePath) {
      return _helper["default"].normalizePaths(_configurator["default"].files.html.concat(_configurator["default"].files.defaultHTML).map(function (htmlConfiguration) {
        return htmlConfiguration.template.filePath;
      })).includes(filePath) || _configurator["default"].module.preprocessor.ejs.exclude === null ? false : evaluate(_configurator["default"].module.preprocessor.ejs.exclude, filePath);
    },
    include: includingPaths,
    test: /^(?!.+\.html\.ejs$).+\.ejs$/i,
    use: _configurator["default"].module.preprocessor.ejs.additional.pre.map(evaluateMapper).concat({
      loader: 'file?name=[path][name]' + ((_clientnode["default"].isPlainObject(_configurator["default"].module.preprocessor.ejs.options) ? _configurator["default"].module.preprocessor.ejs.options : {
        compileSteps: 2
      }).compileSteps % 2 ? '.js' : '') + "?".concat(_configurator["default"].hashAlgorithm, "=[chunkhash]")
    }, {
      loader: 'extract'
    }, {
      loader: _configurator["default"].module.preprocessor.ejs.loader,
      options: _configurator["default"].module.preprocessor.ejs.options || {}
    }, _configurator["default"].module.preprocessor.ejs.additional.post.map(evaluateMapper))
  },
  // endregion
  // region script
  script: {
    exclude: function exclude(filePath) {
      return evaluate(_configurator["default"].module.preprocessor.javaScript.exclude, filePath);
    },
    include: function include(filePath) {
      var result = evaluate(_configurator["default"].module.preprocessor.javaScript.include, filePath);

      if ([null, undefined].includes(result)) {
        var _iterator14 = _createForOfIteratorHelper(includingPaths),
            _step14;

        try {
          for (_iterator14.s(); !(_step14 = _iterator14.n()).done;) {
            var includePath = _step14.value;
            if (filePath.startsWith(includePath)) return true;
          }
        } catch (err) {
          _iterator14.e(err);
        } finally {
          _iterator14.f();
        }

        return false;
      }

      return Boolean(result);
    },
    test: new RegExp(_configurator["default"].module.preprocessor.javaScript.regularExpression, 'i'),
    use: _configurator["default"].module.preprocessor.javaScript.additional.pre.map(evaluateMapper).concat({
      loader: _configurator["default"].module.preprocessor.javaScript.loader,
      options: _configurator["default"].module.preprocessor.javaScript.options || {}
    }, _configurator["default"].module.preprocessor.javaScript.additional.post.map(evaluateMapper))
  },
  // endregion
  // region html template
  html: {
    // NOTE: This is only for the main entry template.
    main: {
      test: new RegExp('^' + _clientnode["default"].stringEscapeRegularExpressions(_configurator["default"].files.defaultHTML.template.filePath) + '(?:\\?.*)?$'),
      use: _configurator["default"].files.defaultHTML.template.use
    },
    ejs: {
      exclude: function exclude(filePath) {
        return _helper["default"].normalizePaths(_configurator["default"].files.html.concat(_configurator["default"].files.defaultHTML).map(function (htmlConfiguration) {
          return htmlConfiguration.template.filePath;
        })).includes(filePath) || (_configurator["default"].module.preprocessor.html.exclude === null ? false : evaluate(_configurator["default"].module.preprocessor.html.exclude, filePath));
      },
      include: _configurator["default"].path.source.asset.template,
      test: /\.html\.ejs(?:\?.*)?$/i,
      use: _configurator["default"].module.preprocessor.html.additional.pre.map(evaluateMapper).concat({
        loader: 'file?name=' + _path2["default"].join(_path2["default"].relative(_configurator["default"].path.target.asset.base, _configurator["default"].path.target.asset.template), '[name]' + ((_clientnode["default"].isPlainObject(_configurator["default"].module.preprocessor.html.options) ? _configurator["default"].module.preprocessor.html.options : {
          compileSteps: 2
        }).compileSteps % 2 ? '.js' : '') + "?".concat(_configurator["default"].hashAlgorithm, "=[chunkhash]"))
      }, (_clientnode["default"].isPlainObject(_configurator["default"].module.preprocessor.html.options) ? _configurator["default"].module.preprocessor.html.options : {
        compileSteps: 2
      }).compileSteps % 2 ? [] : [{
        loader: 'extract'
      }, {
        loader: _configurator["default"].module.html.loader,
        options: _configurator["default"].module.html.options || {}
      }], {
        loader: _configurator["default"].module.preprocessor.html.loader,
        options: _configurator["default"].module.preprocessor.html.options || {}
      }, _configurator["default"].module.preprocessor.html.additional.post.map(evaluateMapper))
    },
    html: {
      exclude: function exclude(filePath) {
        return _helper["default"].normalizePaths(_configurator["default"].files.html.concat(_configurator["default"].files.defaultHTML).map(function (htmlConfiguration) {
          return htmlConfiguration.template.filePath;
        })).includes(filePath) || (_configurator["default"].module.html.exclude === null ? true : evaluate(_configurator["default"].module.html.exclude, filePath));
      },
      include: _configurator["default"].path.source.asset.template,
      test: /\.html(?:\?.*)?$/i,
      use: _configurator["default"].module.html.additional.pre.map(evaluateMapper).concat({
        loader: 'file?name=' + _path2["default"].join(_path2["default"].relative(_configurator["default"].path.target.base, _configurator["default"].path.target.asset.template), "[name].[ext]?".concat(_configurator["default"].hashAlgorithm, "=") + '[chunkhash]')
      }, {
        loader: 'extract'
      }, {
        loader: _configurator["default"].module.html.loader,
        options: _configurator["default"].module.html.options || {}
      }, _configurator["default"].module.html.additional.post.map(evaluateMapper))
    }
  },
  // endregion
  // Load dependencies.
  // region style
  style: {
    exclude: function exclude(filePath) {
      return _configurator["default"].module.cascadingStyleSheet.exclude === null ? isFilePathInDependencies(filePath) : evaluate(_configurator["default"].module.cascadingStyleSheet.exclude, filePath);
    },
    include: function include(filePath) {
      var result = evaluate(_configurator["default"].module.cascadingStyleSheet.include, filePath);

      if ([null, undefined].includes(result)) {
        var _iterator15 = _createForOfIteratorHelper(includingPaths),
            _step15;

        try {
          for (_iterator15.s(); !(_step15 = _iterator15.n()).done;) {
            var includePath = _step15.value;
            if (filePath.startsWith(includePath)) return true;
          }
        } catch (err) {
          _iterator15.e(err);
        } finally {
          _iterator15.f();
        }

        return false;
      }

      return Boolean(result);
    },
    test: /\.s?css(?:\?.*)?$/i,
    use: _configurator["default"].module.preprocessor.cascadingStyleSheet.additional.pre.map(evaluateMapper).concat({
      loader: _configurator["default"].module.style.loader,
      options: _configurator["default"].module.style.options || {}
    }, {
      loader: _configurator["default"].module.cascadingStyleSheet.loader,
      options: _configurator["default"].module.cascadingStyleSheet.options || {}
    }, _configurator["default"].module.preprocessor.cascadingStyleSheet.loader ? {
      loader: _configurator["default"].module.preprocessor.cascadingStyleSheet.loader,
      options: _clientnode["default"].extend(true, (0, _clientnode.optionalRequire)('postcss') ? {
        postcssOptions: {
          plugins: [].concat(postcssImport ? postcssImport({
            addDependencyTo: _webpack["default"],
            root: _configurator["default"].path.context
          }) : [], _configurator["default"].module.preprocessor.cascadingStyleSheet.additional.plugins.pre.map(evaluateMapper),
          /*
              NOTE: Checking path doesn't work if
              fonts are referenced in libraries
              provided in another location than
              the project itself like the
              "node_modules" folder.
          */
          postcssFontPath ? postcssFontPath({
            checkPath: false,
            formats: [{
              type: 'woff2',
              ext: 'woff2'
            }, {
              type: 'woff',
              ext: 'woff'
            }]
          }) : [], postcssURL ? postcssURL({
            url: 'rebase'
          }) : [], postcssSprites ? postcssSprites({
            filterBy: function filterBy() {
              return new Promise(function (resolve, reject) {
                return (_configurator["default"].files.compose.image ? resolve : reject)();
              });
            },
            hooks: {
              onSaveSpritesheet: function onSaveSpritesheet(image) {
                return _path2["default"].join(image.spritePath, _path2["default"].relative(_configurator["default"].path.target.asset.image, _configurator["default"].files.compose.image));
              }
            },
            stylesheetPath: _configurator["default"].path.source.asset.cascadingStyleSheet,
            spritePath: _configurator["default"].path.source.asset.image
          }) : [], _configurator["default"].module.preprocessor.cascadingStyleSheet.additional.plugins.post.map(evaluateMapper), _configurator["default"].module.optimizer.cssnano && postcssCSSnano ? postcssCSSnano(_configurator["default"].module.optimizer.cssnano) : [])
        }
      } : {}, _configurator["default"].module.preprocessor.cascadingStyleSheet.options || {})
    } : [], _configurator["default"].module.preprocessor.cascadingStyleSheet.additional.post.map(evaluateMapper))
  },
  // endregion
  // Optimize loaded assets.
  // region font
  font: {
    eot: {
      exclude: function exclude(filePath) {
        return _configurator["default"].module.optimizer.font.eot.exclude === null ? false : evaluate(_configurator["default"].module.optimizer.font.eot.exclude, filePath);
      },
      test: /\.eot(?:\?.*)?$/i,
      use: _configurator["default"].module.optimizer.font.eot.additional.pre.map(evaluateMapper).concat({
        loader: _configurator["default"].module.optimizer.font.eot.loader,
        options: _configurator["default"].module.optimizer.font.eot.options || {}
      }, _configurator["default"].module.optimizer.font.eot.additional.post.map(evaluateMapper))
    },
    svg: {
      exclude: function exclude(filePath) {
        return _configurator["default"].module.optimizer.font.svg.exclude === null ? false : evaluate(_configurator["default"].module.optimizer.font.svg.exclude, filePath);
      },
      test: /\.svg(?:\?.*)?$/i,
      use: _configurator["default"].module.optimizer.font.svg.additional.pre.map(evaluateMapper).concat({
        loader: _configurator["default"].module.optimizer.font.svg.loader,
        options: _configurator["default"].module.optimizer.font.svg.options || {}
      }, _configurator["default"].module.optimizer.font.svg.additional.post.map(evaluateMapper))
    },
    ttf: {
      exclude: function exclude(filePath) {
        return _configurator["default"].module.optimizer.font.ttf.exclude === null ? false : evaluate(_configurator["default"].module.optimizer.font.ttf.exclude, filePath);
      },
      test: /\.ttf(?:\?.*)?$/i,
      use: _configurator["default"].module.optimizer.font.ttf.additional.pre.map(evaluateMapper).concat({
        loader: _configurator["default"].module.optimizer.font.ttf.loader,
        options: _configurator["default"].module.optimizer.font.ttf.options || {}
      }, _configurator["default"].module.optimizer.font.ttf.additional.post.map(evaluateMapper))
    },
    woff: {
      exclude: function exclude(filePath) {
        return _configurator["default"].module.optimizer.font.woff.exclude === null ? false : evaluate(_configurator["default"].module.optimizer.font.woff.exclude, filePath);
      },
      test: /\.woff2?(?:\?.*)?$/i,
      use: _configurator["default"].module.optimizer.font.woff.additional.pre.map(evaluateMapper).concat({
        loader: _configurator["default"].module.optimizer.font.woff.loader,
        options: _configurator["default"].module.optimizer.font.woff.options || {}
      }, _configurator["default"].module.optimizer.font.woff.additional.post.map(evaluateMapper))
    }
  },
  // endregion
  // region image
  image: {
    exclude: function exclude(filePath) {
      return _configurator["default"].module.optimizer.image.exclude === null ? isFilePathInDependencies(filePath) : evaluate(_configurator["default"].module.optimizer.image.exclude, filePath);
    },
    include: _configurator["default"].path.source.asset.image,
    test: /\.(?:png|jpg|ico|gif)(?:\?.*)?$/i,
    use: _configurator["default"].module.optimizer.image.additional.pre.map(evaluateMapper).concat({
      loader: _configurator["default"].module.optimizer.image.loader,
      options: _configurator["default"].module.optimizer.image.file || {}
    }, _configurator["default"].module.optimizer.image.additional.post.map(evaluateMapper))
  },
  // endregion
  // region data
  data: {
    exclude: function exclude(filePath) {
      return _configurator["default"].extensions.file.internal.includes(_path2["default"].extname(_helper["default"].stripLoader(filePath))) || (_configurator["default"].module.optimizer.data.exclude === null ? isFilePathInDependencies(filePath) : evaluate(_configurator["default"].module.optimizer.data.exclude, filePath));
    },
    test: /.+/,
    use: _configurator["default"].module.optimizer.data.additional.pre.map(evaluateMapper).concat({
      loader: _configurator["default"].module.optimizer.data.loader,
      options: _configurator["default"].module.optimizer.data.options || {}
    }, _configurator["default"].module.optimizer.data.additional.post.map(evaluateMapper))
  } // endregion

});

if (_configurator["default"].files.compose.cascadingStyleSheet && plugins.MiniCSSExtract) {
  /*
      NOTE: We have to remove the client side javascript hmr style loader
      first.
  */
  loader.style.use.shift();
  loader.style.use.unshift(plugins.MiniCSSExtract.loader);
} // / endregion
// / region apply runtime dev helper


if (htmlAvailable && _configurator["default"].debug && _configurator["default"].development.server.liveReload && !_configurator["default"].injection.entry.normalized.developmentHandler && ['serve', 'test:browser'].includes(_configurator["default"].givenCommandLineArguments[2])) {
  _configurator["default"].injection.entry.normalized.developmentHandler = ['webpack-dev-server/client/index.js?http' + (_configurator["default"].development.server.https ? 's' : '') + "://".concat(_configurator["default"].development.server.host, ":") + _configurator["default"].development.server.port];
  if (_configurator["default"].development.server.hot) _configurator["default"].injection.entry.normalized.developmentHandler.push('webpack/hot/dev-server.js');
} // / endregion
// endregion


var _iterator16 = _createForOfIteratorHelper(_configurator["default"].plugins),
    _step16;

try {
  for (_iterator16.s(); !(_step16 = _iterator16.n()).done;) {
    var pluginConfiguration = _step16.value;
    pluginInstances.push((0, _construct2["default"])(eval('require')(pluginConfiguration.name.module)[pluginConfiguration.name.initializer], (0, _toConsumableArray2["default"])(pluginConfiguration.parameter)));
  } // region configuration

} catch (err) {
  _iterator16.e(err);
} finally {
  _iterator16.f();
}

var customConfiguration = {};
if ((_configuration$path$c = _configurator["default"].path.configuration) !== null && _configuration$path$c !== void 0 && _configuration$path$c.json) try {
  require.resolve(_configurator["default"].path.configuration.json);

  try {
    customConfiguration = require(_configurator["default"].path.configuration.json);
  } catch (error) {
    console.debug('Importing provided json webpack configuration file path ' + "under \"".concat(_configurator["default"].path.configuration.json, "\" failed: ") + _clientnode["default"].represent(error));
  }
} catch (error) {
  console.debug('Optional configuration file "' + "".concat(_configurator["default"].path.configuration.json, "\" not available."));
}

var webpackConfiguration = _clientnode["default"].extend(true, {
  bail: true,
  context: _configurator["default"].path.context,
  devtool: _configurator["default"].development.tool,
  devServer: _configurator["default"].development.server,
  experiments: {
    topLevelAwait: true
  },
  // region input
  entry: _configurator["default"].injection.entry.normalized,
  externals: _configurator["default"].injection.external.modules,
  resolve: {
    alias: _configurator["default"].module.aliases,
    aliasFields: _configurator["default"]["package"].aliasPropertyNames,
    extensions: _configurator["default"].extensions.file.internal,
    mainFields: _configurator["default"]["package"].main.propertyNames,
    mainFiles: _configurator["default"]["package"].main.fileNames,
    modules: _helper["default"].normalizePaths(_configurator["default"].module.directoryNames),
    symlinks: _configurator["default"].module.resolveSymlinks,
    unsafeCache: Boolean((_configuration$cache = _configurator["default"].cache) === null || _configuration$cache === void 0 ? void 0 : _configuration$cache.unsafe)
  },
  resolveLoader: {
    alias: _configurator["default"].loader.aliases,
    aliasFields: _configurator["default"]["package"].aliasPropertyNames,
    extensions: _configurator["default"].loader.extensions.file,
    mainFields: _configurator["default"]["package"].main.propertyNames,
    mainFiles: _configurator["default"]["package"].main.fileNames,
    modules: _configurator["default"].loader.directoryNames,
    symlinks: _configurator["default"].loader.resolveSymlinks
  },
  // endregion
  // region output
  output: {
    filename: _path2["default"].relative(_configurator["default"].path.target.base, _configurator["default"].files.compose.javaScript),
    globalObject: _configurator["default"].exportFormat.globalObject,
    hashFunction: _configurator["default"].hashAlgorithm,
    library: libraryName === '*' ? undefined : libraryName,
    libraryTarget: _configurator["default"].givenCommandLineArguments[2] === 'build:dll' ? 'var' : _configurator["default"].exportFormat.self,
    path: _configurator["default"].path.target.base,
    publicPath: _configurator["default"].path.target["public"],
    umdNamedDefine: true
  },
  performance: _configurator["default"].performanceHints,

  /*
      NOTE: Live-reload is not working if target technology is not set to
      "web". Webpack boilerplate code may not support target
      technologies.
  */
  target: _configurator["default"].targetTechnology.boilerplate,
  // endregion
  mode: _configurator["default"].debug ? 'development' : 'production',
  module: {
    rules: _configurator["default"].module.additional.pre.map(evaluateAdditionalLoaderConfiguration).concat(loader.ejs, loader.script, loader.html.main, loader.html.ejs, loader.html.html, loader.style, loader.font.eot, loader.font.svg, loader.font.ttf, loader.font.woff, loader.image, loader.data, _configurator["default"].module.additional.post.map(evaluateAdditionalLoaderConfiguration))
  },
  node: _configurator["default"].nodeEnvironment,
  optimization: {
    chunkIds: _configurator["default"].debug ? 'named' : 'total-size',
    minimize: _configurator["default"].module.optimizer.minimize,
    minimizer: _configurator["default"].module.optimizer.minimizer,
    moduleIds: _configurator["default"].debug ? 'named' : 'size',
    // region common chunks
    splitChunks: !_configurator["default"].injection.chunks || _configurator["default"].targetTechnology.payload === 'node' || ['build:dll', 'test'].includes(_configurator["default"].givenCommandLineArguments[2]) ? {
      cacheGroups: {
        "default": false,
        defaultVendors: false
      }
    } : _clientnode["default"].extend(true, {
      chunks: 'all',
      cacheGroups: {
        defaultVendors: {
          chunks: function chunks(module) {
            if ((0, _typeof2["default"])(_configurator["default"].inPlace.javaScript) === 'object' && _configurator["default"].inPlace.javaScript !== null) for (var _i6 = 0, _Object$keys = Object.keys(_configurator["default"].inPlace.javaScript); _i6 < _Object$keys.length; _i6++) {
              var _name3 = _Object$keys[_i6];
              if (_name3 === '*' || _name3 === module.name) return false;
            }
            return true;
          },
          priority: -10,
          reuseExistingChunk: true,
          test: /[\\/]node_modules[\\/]/
        }
      }
    }, _configurator["default"].injection.chunks) // endregion

  },
  plugins: pluginInstances
}, (_configuration$cache2 = _configurator["default"].cache) !== null && _configuration$cache2 !== void 0 && _configuration$cache2.main ? {
  cache: _configurator["default"].cache.main
} : {}, _configurator["default"].webpack, customConfiguration);

exports.webpackConfiguration = webpackConfiguration;
if (_configurator["default"].nodeENV !== null) webpackConfiguration.optimization.nodeEnv = _configurator["default"].nodeENV;
if (!Array.isArray(_configurator["default"].module.skipParseRegularExpressions) || _configurator["default"].module.skipParseRegularExpressions.length) webpackConfiguration.module.noParse = _configurator["default"].module.skipParseRegularExpressions;
if ((_configuration$path$c2 = _configurator["default"].path.configuration) !== null && _configuration$path$c2 !== void 0 && _configuration$path$c2.javaScript) try {
  require.resolve(_configurator["default"].path.configuration.javaScript);

  var result;

  try {
    result = require(_configurator["default"].path.configuration.javaScript);
  } catch (error) {
    console.debug('Failed to load given JavaScript configuration file path "' + "".concat(_configurator["default"].path.configuration.javaScript, "\": ") + _clientnode["default"].represent(error));
  }

  if (_clientnode["default"].isPlainObject(result)) if (Object.prototype.hasOwnProperty.call(result, 'replaceWebOptimizer')) exports.webpackConfiguration = webpackConfiguration = result.replaceWebOptimizer;else _clientnode["default"].extend(true, webpackConfiguration, result);
} catch (error) {
  console.debug('Optional configuration file script "' + "".concat(_configurator["default"].path.configuration.javaScript, "\" not available."));
}

if (_configurator["default"].showConfiguration) {
  console.info('Using internal configuration:', _util["default"].inspect(_configurator["default"], {
    depth: null
  }));
  console.info('-----------------------------------------------------------');
  console.info('Using webpack configuration:', _util["default"].inspect(webpackConfiguration, {
    depth: null
  }));
} // endregion


var _default = webpackConfiguration; // region vim modline
// vim: set tabstop=4 shiftwidth=4 expandtab:
// vim: foldmethod=marker foldmarker=region,endregion:
// endregion

exports["default"] = _default;
